
#include "etherxd.h"
#include "dlfcn.h"

/* code for dynamically loading listeners */

void dso_init()
{
    /* based on registry */
    xmlnode self, next;
    void (*etherx_receive)(epacket e, int flag);
    void (*etherx_send_handler)(void *f);
    void *tp_so;
    char *dlerr;
    char *defso;
    epacket e;

    /* XXX more ugly code, this is just prototype hackery, needs to be done the "right way"! */

    debug("dso_init");

    next = xmlnode_get_firstchild(app.config);
    while(next != NULL)
    {           
        if(j_strcmp(xmlnode_get_name(next),"transport") == 0 && xmlnode_get_attrib(next,"dso") != NULL)
        {
            log(LOG_DEBUG,"dso_load",xmlnode_get_attrib(next,"dso"));

            tp_so = dlopen(xmlnode_get_attrib(next,"dso"),RTLD_LAZY);
            dlerr = dlerror();
            if(dlerr != NULL)
            {
                log(LOG_ERROR,"etherx_dso_load",xmlnode_get_attrib(next,"dso"));
                log(LOG_ERROR,"etherx_dso_load_err",dlerr);
                /* XXX try to check for it in sys default dir, we should make sure it isn't already an absolute path first! */
                defso = strgrow(NULL,MODLIBDIR,0,0);
                defso = strgrow(defso,"/",1,0);
                defso = strgrow(defso,xmlnode_get_attrib(next,"dso"),1,0);
                tp_so = dlopen(defso,RTLD_LAZY);
                dlerr = dlerror();
                if(dlerr != NULL)
                {
                    log(LOG_ERROR,"etherx_dso_load",defso);
                    log(LOG_ERROR,"etjerx_dso_load_err",dlerr);
                    free(defso);
                    next = xmlnode_get_nextsibling(next);
                    continue;
                }
                free(defso);
            }

            etherx_send_handler = dlsym(tp_so,"etherx_send_handler");
            dlerr = dlerror();
            if(dlerr != NULL)
            {
                log(LOG_ERROR,"etherx_dso_load",xmlnode_get_attrib(next,"dso"));
                log(LOG_ERROR,"etherx_dso_load",dlerr);
                next = xmlnode_get_nextsibling(next);
                continue;
            }
            (etherx_send_handler)(&manager_onDSO);

            etherx_receive = dlsym(tp_so,"etherx_receive");
            dlerr = dlerror();
            if(dlerr != NULL)
            {
                log(LOG_ERROR,"etherx_dso_load",xmlnode_get_attrib(next,"dso"));
                log(LOG_ERROR,"etherx_dso_load",dlerr);
                next = xmlnode_get_nextsibling(next);
                continue;
            }

            (etherx_receive)(NULL, EPACKET_INIT); /* tell transport to start up */

            e = epacket_new(next,NULL,NULL);
            (etherx_receive)(e, EPACKET_REGISTRY);

            /* store etherx_receive and the id in a global array */
        }
        next = xmlnode_get_nextsibling(next);
    }
}

/***************************
*** code from quest on how to do this, new to me!
*** gcc -rdynamic -pedantic -o foo main.c -ldl
*** gcc -pedantic -Wall -shared lib.c -o dalib.so

#include <stdio.h>
#include <dlfcn.h>


int main (int argc, char **argv)
{
    void *(*dafunc)(void);
    void (*callthis)(char *);
    void *dalib;
    dalib = dlopen ("dalib.so", RTLD_LAZY);
    if (dlerror() != NULL) fputs (dlerror(), stderr);
    dafunc = dlsym (dalib, "dafunc");
    if (dlerror() != NULL) fputs (dlerror(), stderr);
    callthis = (dafunc)();
    (callthis)("Hello world");
    dlclose (dalib);
}

File lib.c:
#include <stdio.h>

void callthis (char *dastr)
{
    puts (dastr);
}
void *dafunc (void)
{
    return callthis;
}

*******************************/
