#include "etherxd.h"

/* code for logging
    - setup internal/lib error log
    - create special connection log
*/

void logger_init()
{
    xmlnode self, next;
    char *conlog = NULL;
    int log_level = LOG_WARN;

    debug("logger_init()");

    self = xmlnode_get_child(app.config,"etherx");
    if(self != NULL)
    {
        next = xmlnode_get_firstchild(self);
        while(next != NULL)
        {
            if(j_strcmp(xmlnode_get_name(next),"log") == 0)
                conlog = xmlnode_get_data(next);
            next = xmlnode_get_nextsibling(next);
        }
    }

    log_init(LOG2_STDERR,NULL,NULL); /* change to use config errorlog value */

    if(xmlnode_get_attrib(app.arg,"-D") != NULL)
        log_level = LOG_DEBUG;    

    /* start connection log */
    log(LOG_DEBUG,"logger_init_file",conlog);
}

void conlog(int phase, void *conn)
{
    /* log to connection log */
}

