
typedef struct epacket_struct
{
    xmlnode x;
    char *to;
    char *from;
    char *error;
    int type;
    int flag;
} _epacket, *epacket;

#define EPACKET_NORMAL 0 /* default */
#define EPACKET_REGISTRY 1 /* special flag that this is a registry packet */
#define EPACKET_ERROR 2 /* special flag that this is an error/bounced packet */
#define EPACKET_INIT 3 /* initialization signal, always the first call */

#define EPACKET_FLAG_NONE 0 /* defalt */
#define EPACKET_FLAG_LOCAL 1 /* originated locally */
#define EPACKET_FLAG_REMOTE 2 /* originated remotely */


/* public functions */

void etherx_send(epacket e);
int etherx_init(char *id, char *secret, char *host, void (*receive)(epacket e, int flag));
epacket epacket_new(xmlnode x, char *to, char *from); /* if to/from are null it extracts them from x */


/* internal functions */

void _etherx_receive(thread t, xmlnode x, int flag); /* callback for xmlstream when doing socket connects */
