#ifndef INCL_JABBER_H
#define INCL_JABBER_H


#define JPMESSAGE_NORMAL 0
#define JPMESSAGE_ERROR 1
#define JPMESSAGE_CHAT 2
#define JPMESSAGE_GROUPCHAT 3

typedef struct jpmessage_struct
{
    jpacket jp;
    int type; /* JPMESSAGE_* */
    char *thread;
    int priority;
    char *subject;
    char *say;
    xmlnode say_x;
    xmlnode ext_x;
} *jpmessage;

jpmessage jabber_message(jpacket jp); /* Extracts the message info from a jpacket, uses jp->pool */


#define JPPRESENCE_NORMAL 0
#define JPPRESENCE_SUBSCRIBE 1
#define JPPRESENCE_UNSUBSCRIBE 2
#define JPPRESENCE_AVAILABLE 3
#define JPPRESENCE_UNAVAILABLE 4
#define JPPRESENCE_PROBE 5

typedef struct jppresence_struct
{
    jpacket jp;
    int type; /* JPPRESENCE_* */
    int priority;
    char *say;
    xmlnode ext_x;
} *jppresence;

jppresence jabber_presence(jpacket jp); /* Extracts the presence info from a jpacket, uses jp->pool */


#define JPROSTER_NONE 0
#define JPROSTER_DEL 1
#define JPROSTER_ADD 2
#define JPROSTER_GET 3

#define JPIQTARGET_NONE 0
#define JPIQTARGET_USER 1
#define JPIQTARGET_CLIENT 2
#define JPIQTARGET_SERVER 3
#define JPIQTARGET_SEARCH 4

#define JPIQSTATUS_NONE 0
#define JPIQSTATUS_QUERY 1
#define JPIQSTATUS_RESULT 2
#define JPIQSTATUS_SET 3

typedef struct jpiq_struct
{
    jpacket jp;
    int target; /* JPIQTARGET_* */
    int status; /* JPIQSTATUS_* */
    char *type;
    xmlnode data_x;
} *jpiq;

jpiq jabber_iq(jpacket jp); /* Extracts the query info from a jpacket, uses jp->pool */


#endif
