#ifndef INCL_JPACKET_H
#define INCL_JPACKET_H

/* convenience structs for use within the app */

typedef struct jid_struct
{ /* type=user/resource@server */
    char *resource;
    char *user;
    char *server;
    char *type;
} *jid;

#define JPACKET_UNKNOWN 0
#define JPACKET_MESSAGE 1
#define JPACKET_PRESENCE 2
#define JPACKET_IQ 3

typedef struct jabber_struct
{
    int type;
    int flag;
    void *aux1;
    xmlnode x;
    jid to;
    jid from;
    pool p;
} *jpacket, _jpacket;

jid jabber_id(xmlnode x); /* Creates a jabber id struct from the xmlnode */
jpacket jabber_packet(xmlnode x); /* Creates a jabber packet from the xmlnode */
void jabber_packet_free(jpacket jp); /* frees the jabber packet and all data within it including the pool */

#endif
