#include <stdio.h>
#include "jabber/jlib.h"  

struct app_struct app;

void app_init(int argc, char *argv[])
{   	
    /* converts the command line args to an xmlnode, and converts environment vars to xmlnode to store in global app var */
    /* looks at command line and sets log_level appropriately */
    sigset_t sigs;    
	int i;	
	
    /* init pth */
    pth_init();	

    /* block signals for io lib functions, SIGUSR2 used internally
    sigemptyset(&sigs);
    pth_sigmask(SIG_SETMASK, NULL, &sigs);
    sigaddset(&sigs, SIGUSR2);
    pth_sigmask(SIG_SETMASK, &sigs, NULL); */

	/* initialize the global container */
    app.arg = xmlnode_new_tag("arg");
    app.env = xmlnode_new_tag("env");
    app.global = NULL;
    app.config = NULL;
    app.log_level = LOG_WARN;
    app.log_thread = NULL;

    i = 1;	
    while(i < argc-1)
    {   		
        if((argv[i][0] == '-') && (i+1 < argc) && (argv[i+1][0] != '-')) // -flag option 
        {
            xmlnode_put_attrib(app.arg, argv[i], argv[i+1]);
            i += 2;
        }else{
            xmlnode_put_attrib(app.arg, argv[i], "NULL");
            i++;
        }
    }
}
