#include "jabber/jlib.h"

jid jabber_id(xmlnode x)
{
    char *user, *server, *resource, *type, *str;
    jid id;

    str = xmlnode_get_data(x);
    if(x == NULL || str == NULL)
        return NULL;

    id = pmalloc(xmlnode_pool(x),sizeof(struct jid_struct));
    id->server = id->user = id->resource = id->type = NULL;

    server = strstr(str,"@");
    if(server != NULL)
    {
        *server = '\0';
        ++server;
        id->server = server;
    }

    resource = strstr(str,"/");
    if(resource != NULL)
    {
        *resource = '\0';
        ++resource;
        id->resource = resource;
    }
    
    user = strstr(str,"=");
    if(user != NULL)
    {
        *user = '\0';
        ++user;
        id->user = user;
        id->type = str;
    }else{
        id->user = str;
    }
        
    return id;
}

jpacket jabber_packet(xmlnode x)
{
    jpacket p;
    xmlnode next;

    p = pmalloc(xmlnode_pool(x),sizeof(_jpacket));
    p->x = x;

    p->type = JPACKET_UNKNOWN;
    if(j_strcmp(xmlnode_get_name(x),"message") == 0)
        p->type = JPACKET_MESSAGE;
    if(j_strcmp(xmlnode_get_name(x),"presence") == 0)
        p->type = JPACKET_PRESENCE;
    if(j_strcmp(xmlnode_get_name(x),"iq") == 0)
        p->type = JPACKET_IQ;

    next = xmlnode_get_firstchild(x);
    while(next != NULL)
    {
        if(j_strcmp(xmlnode_get_name(next),"to") == 0)
            p->to = jabber_id(next);
        if(j_strcmp(xmlnode_get_name(next),"from") == 0)
            p->from = jabber_id(next);
        next = xmlnode_get_nextsibling(next);
    }
}


