#include "jabber/jlib.h"

void log_init(int log2, void *arg1, void *arg2)
{
    int fd;
	/* creates tstream on whatever LOG2_ and stores in app.log_ts */

    switch(log2)
    {
        case LOG2_NONE:
            app.log_level = -1;
            break;
        case LOG2_FILE:
            fd = open (arg1, O_WRONLY | O_CREAT);
            app.log_thread = tstream_new(fd, NULL, NULL);
            break;
        default:
            app.log_thread = (thread)log2;
            break;
    }

    log(LOG_DEBUG,"logger","log_init()");
}

void _log(int level, char *zone, const char *message)
{
    /* tstream_write the message to the app.log_ts */
    static char logmsg[1024];
    static int size;

    /*if(level > app.log_level) // Not needed anymore as the macro handles this?
        return;*/

    switch(level)
    {
        case LOG_ERROR:
            size = snprintf(logmsg, 1024, "Error: %s '%s'\n", zone, message);
            break;
        case LOG_WARN:
            size = snprintf(logmsg, 1024, "Warning: %s '%s'\n", zone, message);
            break;
        case LOG_DEBUG:
            size = snprintf(logmsg, 1024, "DEBUG: %s '%s'\n", zone, message);
            break;
        case LOG_INSANE:
            size = snprintf(logmsg, 1024, "URNuts: %s '%s'\n", zone, message);
            break;
    }


    /*!!! need to truncate more intelligently here */
    if(size == -1)
        size = 1023;

    switch((int)app.log_thread)
    {
        case NULL:
            printf("%s",logmsg);
            break;
        case LOG2_STDERR:
            fprintf(stderr,"%s",logmsg);
            break;
        case LOG2_SYSLOG:
            /*!!! print logmsg to syslog */
            break;
        default:
            tstream_write(app.log_thread, logmsg, size);
            break;
    }
}

