#include "jabber/jlib.h"

pool pool_new()
{
    pool p;
    p = malloc(sizeof(_pool));
    p->size = 0;
    p->block = NULL;
    p->next = NULL;
    p->key = NULL;
/*printf("POOL|NEW [%d]\n",p);*/
    return p;
}

void *pmalloc(pool p, int size)
{
    void *block = NULL;
    pool new;

    block = malloc(size);

    if(p == NULL) /* this is most likely an error that we got a NULL here! */
    {
        log(LOG_WARN, "jlib", "pmalloc received NULL pool, memory leak!");
    }else{
        new = malloc(sizeof(_pool));
        new->size = size;
        new->block = block;
        new->next = p->next;
        p->next = new;
    }

/*printf("POOL|BLK [%d] [%d]\n",p,block);*/
    return block;
}

void *pmalloc_key(pool p, int key, int size)
{
    void *block = NULL;
    pool next;

    next = p;
    while(next != NULL)
    {
        if(next->key == key)
            return next->block;
        next = next->next;
    }

    if(size != 0)
    {
        block = pmalloc(p, size);
        p->next->key = key;
    }

    return block;
}

char *pstrdup(pool p, const char *src)
{
    char *ret;

    if(src == NULL)
        return NULL;

    ret = pmalloc(p,strlen(src) + 1);
    strcpy(ret,src);

    return ret;
}

void pool_free(pool p)
{
    pool next = p;
/*printf("POOL|FRE [%d]\n",p);*/
    while(next != NULL)
    {
        p = next;
        next = p->next;
/*printf("POOL|BLKFRE [%d]\n",p->block);*/
        free(p->block);
        free(p);
    }
}
