#include <jabber/jlib.h>
#include <jabber/etherx.h>

#define JP_UNKNOWN 0
#define JP_INCOMING 1
#define JP_DELIVER 2
#define JP_SEND 3

#define JP_FLAG_NONE 0
#define JP_FLAG_AUTHREQ 1
#define JP_FLAG_AUTHOK 2

#define CMD_SET 0
#define CMD_GET 1
#define CMD_CHECK 2
#define CMD_DEL 3

#define M_FLAG_OK 0
#define M_FLAG_IGNORE_PHASE 1
#define M_FLAG_IGNORE_SESSION 2

#define M_PHASE_NONE 0
#define M_PHASE_AUTH 1
#define M_PHASE_SESSION_ON 2
#define M_PHASE_SESSION_OFF 3
#define M_PHASE_MESSAGE_IN 4
#define M_PHASE_MESSAGE_OUT 5
#define M_PHASE_PRESENCE_IN 6
#define M_PHASE_PRESENCE_OUT 7
#define M_PHASE_IQ_IN 8
#define M_PHASE_IQ_OUT 9

#define RESOURCE_SESSION 0
#define RESOURCE_REMOTE 1

char *config_names(int cmd, char *name);
char *config_transports(int cmd, xmlnode x);
void config_service(xmlnode x);
void config_startup(void);

void etherx_receive(epacket e, int flag);

typedef struct resource_struct
{
    int type;
    char *user;
    char *res;
    pth_msgport_t handler;
    struct resource_struct *next;
} _resource, *resource;

resource resource_create(int type, char *user, char *res, pth_msgport_t handler);
resource resource_lookup(char *user, char *res);
void resource_free(resource r);
void deliver(jpacket p);
void unknown_main();
jid remote(int cmd, char *user, char *res, jid real);
void remote_main();

typedef struct session_struct
{
    resource r;
    pool *p;
    void *onSend;
    void *onSend_data;
    struct session_struct *next;
} _session, *session;

thread session_create(jid owner, void *onSend, void *onSend_data);






