#include "jserver.h"
#include "dlfcn.h"

/* loads the shared object and calls the init function */
int dso_load(char *so, char *init, void *arg)
{
    void (*init_h)(void *arg);
    void *so_h;
    char *dlerr;
    char *defso;

    debug("dso_init");

    so_h = dlopen(so,RTLD_LAZY);
    dlerr = dlerror();
    if(dlerr != NULL)
    {
        log(LOG_ERROR,"jserver_dso_load",so);
        log(LOG_ERROR,"jserver_dso_load_err",dlerr);
        defso = strgrow(NULL,MODLIBDIR,0,0);
        defso = strgrow(defso,"/",1,0);
        defso = strgrow(defso,so,1,0);
        so_h = dlopen(defso,RTLD_LAZY);

        dlerr = dlerror();
        if(dlerr != NULL)
        {
            log(LOG_ERROR,"jserver_dso_load",defso);
            log(LOG_ERROR,"jserver_dso_load_err",dlerr);
            free(defso);
            return -1;
        }
        free(defso);
    }

    init_h = dlsym(so_h,init);
    dlerr = dlerror();
    if(dlerr != NULL)
    {
        log(LOG_ERROR,"jserver_dso_init",init);
        log(LOG_ERROR,"jserver_dso_init_err",dlerr);
    }
    (init_h)(arg);

    return 0;
}



