#include "jserver.h"


void modules_init(xmlnode x)
{
    /* use dso and load/init configured modules */

    /* upon reconfigure just call modules's config phase again, can't [un]load dso stuff w/o restart */
}

typedef struct mapi_struct
{
    session s;
    jpacket p;
    /* other objects passed to modules for all dispatch calls */
} *mapi;

struct module
{
    void *dispatch;
    /* XXX some sort of bitmask for which phases this dispatch handles */
    pool p;
    struct module *next;
};

struct module *modules = NULL;

int module_register(pool p, void *dispatch)
{
    struct module *m;

    m = pmalloc(p, sizeof(struct module));
    m->p = p;
    m->dispatch = dispatch;
    m->next = modules;
    modules = m;

    return 1;
}

int module_dispatch(int phase, session s, jpacket p)
{
    struct module *next;
    int (*dispatch)(int phase, mapi m);
    int ret;
    mapi m;

    m = malloc(sizeof(struct mapi_struct));
    m->s = s;
    m->p = p;

    next = modules;
    while(next != NULL)
    {
        /* XXX check this session's pool for a special block containing know list of dispatches for this session */
        /* XXX check bitmask, maybe this dispatch ignores this phase */
        m->p = next->p;
        dispatch = next->dispatch;
        ret = (*dispatch)(phase, m);
        switch(ret)
        { /* XXX set bitmask if it returns an ignore flag, create special list for dispatches for this session */
            case M_FLAG_OK:
                break;
            case M_FLAG_IGNORE_PHASE:
                break;
            case M_FLAG_IGNORE_SESSION:
                break;
        }
        next = next->next;
    }
}
