#include "jserver.h"

jid remote(int cmd, char *user, char *res, jid real)
{
    switch(cmd)
    {
        case CMD_GET:
            /* called by the remote thread to find the real jid */
            break;
        case CMD_CHECK:
            /* used by a user's session to check if the sender is one if their remote resources */
            break;
        case CMD_SET:
            resource_create(RESOURCE_REMOTE, user, res, pth_msgport_find("remote"));
            /* save this remote resource in a static lookup table */
            break;
        case CMD_DEL:
            /* delete this remote resource */
            break;
    }
}

/* thread that handles data for remote resources */
void remote_main()
{
    pth_event_t ev;
    pth_msgport_t mp;
    jpacket p;
    
    mp = pth_msgport_create("remote");
    ev = pth_event(PTH_EVENT_MSG,mp);

    while(1)
    {
        pth_wait(ev);
        while(p = pth_msgport_get(mp) != NULL)
        {
            /* call remote(REMOTE_FIND,p->to->user, p->to->res, NULL) */
            /* replace to with return and deliver to external_mp */
        }
    }
    
    pth_event_free(ev,PTH_FREE_ALL);
    pth_msgport_destroy(mp);
}
